﻿--[[
	Author: Darcey@AllForTheCode.co.uk
--]]


-- var def/init
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #



-- initFunctions
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function initDCoordsMenuFrame()

      DCoordsMenuFrame = CreateFrame("frame","DCoordsMenuFrame")
      DCoordsMenuFrame:SetBackdrop({
            bgFile="Interface\\DialogFrame\\UI-DialogBox-Background", 
            edgeFile="Interface\\DialogFrame\\UI-DialogBox-Border", 
            tile=1, tileSize=32, edgeSize=32, 
            insets={left=11, right=12, top=12, bottom=11}
      })
      DCoordsMenuFrame:SetWidth(350)
      DCoordsMenuFrame:SetHeight(400)
      DCoordsMenuFrame:EnableMouse(true)
      DCoordsMenuFrame:SetMovable(true)
      DCoordsMenuFrame:SetPoint("CENTER",UIParent,0,0)
      DCoordsMenuFrame:RegisterForDrag("LeftButton")
      DCoordsMenuFrame:SetScript("OnDragStart", function(self) self:StartMoving() end)
      DCoordsMenuFrame:SetScript("OnDragStop", function(self) self:StopMovingOrSizing() end)
      DCoordsMenuFrame:SetFrameStrata("FULLSCREEN_DIALOG")

      -- Frame titles
      local DCoordsMenuFrame_Title1 = createText(DCoordsMenuFrame,"DCoords v"..DCoordsVersion,20,15,-11);
      local DCoordsMenuFrame_Title2 = createText(DCoordsMenuFrame,"Darcey@AllForTheCode.co.uk",9,15.5,-29);
      
      -- Checkboxes
      -- function createCheckbox(frame,id,label,size,x,y)
      local cbY = -46;
      local cbInc = 26;
      cbShowDCoords = createCheckbox(DCoordsMenuFrame,"cbShowDCoords","Show DCoords",12,18,cbY,"cbShowDCoordsHandler");
      cbY = cbY - cbInc;
      cbEnableDrag = createCheckbox(DCoordsMenuFrame,"cbEnableDrag","Enable left click drag",12,18,cbY,"cbEnableDragHandler");
      cbY = cbY - cbInc;
      cbShowZone = createCheckbox(DCoordsMenuFrame,"cbShowZone","Show zone",12,18,cbY,"cbShowZoneHandler");
      cbY = cbY - cbInc;
      cbShowSubZone = createCheckbox(DCoordsMenuFrame,"cbShowSubZone","Show sub zone",12,18,cbY,"cbShowSubZoneHandler");
      cbY = cbY - cbInc;
      cbShowBackground = createCheckbox(DCoordsMenuFrame,"cbShowBackground","Show background",12,18,cbY,"cbShowBackgroundHandler");
      cbY = cbY - cbInc;
      cbShowMapCoordinates = createCheckbox(DCoordsMenuFrame,"cbShowMapCoordinates","Show map coordinates",12,18,cbY,"cbShowMapCoordinatesHandler");
      cbY = cbY - cbInc;

      -- Sliders
      --local SetMainFrameTextColorLabel = createText(DCoordsMenuFrame,"Coordinates font color (R,G,B White is 1|1|1)",12,156,-40);
      --local s1 = createSlider(frame,id,x,y,min,max,default,label,width)
      local pY = -48;
      local pInc = 40;
      sliderDecimalPrecision = createSlider(DCoordsMenuFrame,"sliderDecimalPrecision",160,pY,0,3,1,"Decimal places to display",160,"sliderDecimalPrecisionChangeHandler");
      sliderDecimalPrecision:SetValueStep(1);
      pY = pY - pInc;
      sliderTextR = createSlider(DCoordsMenuFrame,"sliderTextR",160,pY,0,1,1,"Coordinates main font color Red (R)",160,"sliderRChangeHandler");
      pY = pY - pInc;
      sliderTextG = createSlider(DCoordsMenuFrame,"sliderTextG",160,pY,0,1,1,"Coordinates main font color Green (G)",160,"sliderGChangeHandler");
      pY = pY - pInc;
      sliderTextB = createSlider(DCoordsMenuFrame,"sliderTextB",160,pY,0,1,1,"Coordinates main font color Blue (B)",160,"sliderBChangeHandler");
      pY = pY - pInc;
      sliderTextA = createSlider(DCoordsMenuFrame,"sliderTextA",160,pY,0,1,1,"Coordinates main font Alpha (A)",160,"sliderAChangeHandler");
      pY = pY - pInc;
      sliderMainFontSize = createSlider(DCoordsMenuFrame,"sliderMainFontSize",160,pY,8,100,DCoords_MainFrameFontSize,"Coordinates main font size",160,"sliderMainFontSizeChangeHandler");
      pY = pY - pInc;
      sliderMapFontSize = createSlider(DCoordsMenuFrame,"sliderMapFontSize",160,pY,8,100,DCoords_MapFrameFontSize,"Coordinates map font size",160,"sliderMapFontSizeChangeHandler");
      pY = pY - pInc;
      
      
      
      -- font dropdown
      dropDown = CreateFrame("FRAME", "DCoordsFontSelectionDropDown", DCoordsMenuFrame, "UIDropDownMenuTemplate")
	dropDown:SetPoint("TOPLEFT", 140, pY)
      
	UIDropDownMenu_SetWidth(dropDown, 148)
	UIDropDownMenu_SetText(dropDown, "Font " .. DCoords_MainFrameFont)
      UIDropDownMenu_Initialize(dropDown, function(self, level, menuList)
            local info = UIDropDownMenu_CreateInfo()
            info.func = self.SetValue;
            for i=1,#fontFiles do
                  info.text, info.arg1, info.checked = "Font " .. tostring(i), i, false;
                  UIDropDownMenu_AddButton(info);
            end
            
      end)
      
	function dropDown:SetValue(newValue)
		DCoords_MainFrameFont = newValue;
		--log("Now using font: " .. getMainFrameFont());
		UIDropDownMenu_SetText(dropDown, "Font: " .. getMainFrameFontName())	
		updateDCoordsMainFrame();
            updateDCoordsMapFrameState();
	end      
      
      
      
      -- Buttons
      local btnClose = CreateFrame("button","btnClose", DCoordsMenuFrame, "UIPanelButtonTemplate")
      btnClose:SetHeight(24)
      btnClose:SetWidth(30)
      btnClose:SetPoint("TOPRIGHT", 2, 2)
      btnClose:SetText("X")
      btnClose:SetScript("OnClick", function(self) playClick(); self:GetParent():Hide(); end)
      
      
      -- Buttons
      local btnReset = CreateFrame("button","btnReset", DCoordsMenuFrame, "UIPanelButtonTemplate")
      btnReset:SetHeight(24)
      btnReset:SetWidth(150)
      btnReset:SetPoint("BOTTOMRIGHT", -14, 16)
      btnReset:SetText("RESET DCOORDS")
      btnReset:SetScript("OnClick", function(self) 
            reset();
      end)
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #



-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
reset = function()      
      DCoords_MainFrameVisible = true;
      DCoords_MainFrameX = 0;
      DCoords_MainFrameY = 0;
      DCoords_MainFrameWidth = 150;
      DCoords_MainFrameHeight = 10;
      DCoords_MainFrameShowBg = true;
      DCoords_MainFrameBgAlpha = 1;
      DCoords_MainFrameFont = 1;
      DCoords_MainFrameFontSize = 13;
      DCoords_MainFrameTextR = 1;
      DCoords_MainFrameTextG = 1;
      DCoords_MainFrameTextB = 1;
      DCoords_MainFrameTextAlpha = 1;
      DCoords_MainFrameDragEnabled = true;
      DCoords_MainFrameShowZone = true;
      DCoords_MainFrameShowSubZone = true;
      DCoords_MainFrameDecimalPrecision = 3;

      DCoords_MapFrameVisible = true;
      DCoords_MapFrameFont = 1;
      DCoords_MapFrameFontSize = 16;
      DCoords_MapFrameTextAlpha = 1;
      DCoords_MapFrameSingleDecimal = true;
      
      
      updateDCoordsMainFrame();
      updateDCoordsMenuFrameState();
      
      dropDown:SetValue(DCoords_MainFrameFont);
      
      DCoordsMainFrame:ClearAllPoints();
      DCoordsMainFrame:SetPoint("CENTER",0,0);
      --DCoordsMainFrame:SetPoint("BOTTOMLEFT",UIParent,GetScreenWidth()/2.3,GetScreenHeight()/2.3);
      
      DCoordsMenuFrame:ClearAllPoints();
      DCoordsMenuFrame:SetPoint("CENTER",0,0);
      
      log("DCoords reset complete!");
      PlaySound("QUESTADDED");
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #




-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function updateDCoordsMenuFrameState()
      cbShowDCoords:SetChecked(DCoords_MainFrameVisible);
      cbEnableDrag:SetChecked(DCoords_MainFrameDragEnabled);
      
      cbShowZone:SetChecked(DCoords_MainFrameShowZone);
      cbShowSubZone:SetChecked(DCoords_MainFrameShowSubZone);
      cbShowBackground:SetChecked(DCoords_MainFrameShowBg);
      
      cbShowMapCoordinates:SetChecked(DCoords_MapFrameVisible);
      
      sliderDecimalPrecision:SetValue(DCoords_MainFrameDecimalPrecision);
      sliderTextR:SetValue(DCoords_MainFrameTextR);
      sliderTextG:SetValue(DCoords_MainFrameTextG);
      sliderTextB:SetValue(DCoords_MainFrameTextB);
      sliderTextA:SetValue(DCoords_MainFrameTextAlpha);
      sliderMainFontSize:SetValue(DCoords_MainFrameFontSize);
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #



-- eventHandlerFunctions
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function sliderMainFontSizeChangeHandler(value)
      DCoords_MainFrameFontSize = value;
      updateDCoordsMainFrame();
end
function sliderMapFontSizeChangeHandler(value)
      log("sliderMapFontSizeChangeHandler(): " .. value);
      DCoords_MapFrameFontSize = value;
      updateDCoordsMapFrameState();
end


function sliderDecimalPrecisionChangeHandler(value)
      DCoords_MainFrameDecimalPrecision = value;
end
function sliderAChangeHandler(value)
      DCoords_MainFrameTextAlpha = value;
      DCoordsMainFrameText:SetTextColor(DCoords_MainFrameTextR,DCoords_MainFrameTextG,DCoords_MainFrameTextB,DCoords_MainFrameTextAlpha);
end
function sliderRChangeHandler(value)
      DCoords_MainFrameTextR = value;
      DCoordsMainFrameText:SetTextColor(DCoords_MainFrameTextR,DCoords_MainFrameTextG,DCoords_MainFrameTextB,DCoords_MainFrameTextAlpha);
end
function sliderGChangeHandler(value)
      DCoords_MainFrameTextG = value;
      DCoordsMainFrameText:SetTextColor(DCoords_MainFrameTextR,DCoords_MainFrameTextG,DCoords_MainFrameTextB,DCoords_MainFrameTextAlpha);
end
function sliderBChangeHandler(value)
      DCoords_MainFrameTextB = value;
      DCoordsMainFrameText:SetTextColor(DCoords_MainFrameTextR,DCoords_MainFrameTextG,DCoords_MainFrameTextB,DCoords_MainFrameTextAlpha);
end
function cbShowDCoordsHandler(checked)
      DCoords_MainFrameVisible = checked;
      updateDCoordsMainFrame();
end
function cbEnableDragHandler(checked)
      DCoords_MainFrameDragEnabled = checked;
      updateDCoordsMainFrame();
end
function cbShowZoneHandler(checked)
      DCoords_MainFrameShowZone = checked;
end
function cbShowSubZoneHandler(checked)
      DCoords_MainFrameShowSubZone = checked;
end
function cbShowBackgroundHandler(checked)
      DCoords_MainFrameShowBg = checked;
      updateDCoordsMainFrame();
end
function cbShowMapCoordinatesHandler(checked)
      DCoords_MapFrameVisible = checked;
      updateDCoordsMapFrameState();
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #




-- init/constructor
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
-- See DCoords.lua > DCoordsEventFrame
